function [cs ch]=cov_grad(Amat,node1,node2,cl,cnew,g_samp,z_samp,CCnew,nz_pop,nzero_samp,est_old,svec,beta)
% compute the gradient and hessian of the approximated log-likelihood wrt latent parameter theta_tilda %
S=CCnew(g_samp(cnew(g_samp)==node1),cnew==node2,:);
srsmat=z_samp(:,cnew(g_samp)==node1);
[s1,s2]=size(srsmat);
[~,colsub]=find(srsmat);
vec=g_samp(cnew(g_samp)==node1);
rowvec=vec(colsub);
colvec=reshape(srsmat,s1*s2,1);
linearInd=sub2ind(size(CCnew(:,:,1)),rowvec,colvec);
[dim1,dim2,dim3]=size(CCnew);
S1=reshape(CCnew,dim1*dim2,dim3);
S1_trn=S1(linearInd,:);
[d1 d2 d3]=size(S);
S_trn=reshape(S,d1*d2,d3);
Snew=beta'*S_trn';
S1new=beta'*S1_trn';
Snew_trn=reshape(Snew,d1,d2);
S1new_trn=reshape(S1new,s1,s2);
G=cnew(z_samp(:,cnew(g_samp)==node1));
B=sum(svec(cl(g_samp(cnew(g_samp)==node1))).*sum(Amat(g_samp(cnew(g_samp)==node1),cnew==node2).*(1-(exp(est_old(node1,node2)+ Snew_trn)./(1+exp(est_old(node1,node2)+ Snew_trn)))),2));
C=-sum(svec(cl(g_samp(cnew(g_samp)==node1))).*sum(Amat(g_samp(cnew(g_samp)==node1),cnew==node2).*(exp(est_old(node1,node2)+ Snew_trn)./(1+exp(est_old(node1,node2)+ Snew_trn)).^2),2));
B1=sum(svec(cl(g_samp(cnew(g_samp)==node1))).*(nz_pop(cnew(g_samp)==node1)/nzero_samp).*sum((exp(est_old(node1,node2)+ S1new_trn)./(1+exp(est_old(node1,node2)+ S1new_trn))).*(G==node2),1)');
C1=-sum(svec(cl(g_samp(cnew(g_samp)==node1))).*(nz_pop(cnew(g_samp)==node1)/nzero_samp).*sum((exp(est_old(node1,node2)+ S1new_trn)./(1+exp(est_old(node1,node2)+ S1new_trn)).^2).*(G==node2),1)');
cs=B-B1;
ch=C+C1;
end