function [chat,phat,pri_hat]=parEM(numgibbs,linkmat,nodelabel,pi_prob,A,zsamp,ssvec,sizevec,numsamp,numcon,nz_pop,ksize,nsize)
% Function that calculates the parameter estimates via Monte-Carlo EM and
% updates the labels accordingly
psum=zeros(ksize,ksize);
pi_sum=zeros(ksize,1);
plink_cc=zeros(ksize,ksize);
for m=1:numgibbs
    csamp = gibbs_ccstr(linkmat,nodelabel,pi_prob,A,zsamp,ssvec,numsamp,nz_pop,numcon,ksize);
    for u=1:ksize
        for v=1:ksize
            if(v>=u)
                plink_cc(u,v)=(strcc_commsum(A,u,v,nodelabel,csamp,sizevec,ssvec) + strcc_commsum(A,v,u,nodelabel,csamp,sizevec,ssvec))/(strcc_commsum(A,u,v,nodelabel,csamp,sizevec,ssvec)+strcc_commsum(A,v,u,nodelabel,csamp,sizevec,ssvec)+strcc_zerosum(nodelabel,csamp,u,v,zsamp,numcon,nz_pop,ssvec,sizevec)+strcc_zerosum(nodelabel,csamp,v,u,zsamp,numcon,nz_pop,ssvec,sizevec));
            else
                plink_cc(u,v)=plink_cc(v,u);
            end
        end
    end
    psum=psum+plink_cc;
    uv = unique(csamp);
    czero=ismember((1:ksize),uv);
    czero=double(czero);
    hh=histc(csamp,uv)/nsize;
    czero(czero==1)=hh(1:end)';
    pi_sum =pi_sum + czero';
end
chat=csamp;
phat=psum/numgibbs;
pri_hat = pi_sum/numgibbs;
end