%% Gibbs Sampling for drawing the latent labels in case-control approximation %%
function lsamp = gibbs_ccstr(prob_mat,cl,class_prob,Amat,z_samp,g_samp,nsamp_str,nz_pop,nzero_samp,ksize)
%prob.vector=repmat(class_prob,[1 nsize]);
cnew=cl;

%for r=1:2
    for s=1:nsamp_str
        B=(Amat(g_samp(s),:)==1);
        %z_pop=find(A(g_samp(s),:)==0);
        %z_pop(z_pop==g_samp(s))=[];
        C=z_samp(:,s);
        C(C==g_samp(s))=[];
        w_org=sum(log(prob_mat(1:ksize,cnew(B))),2) + (nz_pop(s)/nzero_samp).* sum(log((1-prob_mat(1:ksize,cnew(C)))),2)+ log(class_prob);
        w_scaled=w_org-max(w_org);
        %prob.vector(:,g_samp(s))=sum(log(prob_mat(1:ksize,cnew(B))),2) + (nz_pop(s)/nzero_samp).* sum(log((1-prob_mat(1:ksize,cnew(C)))),2) + log(class_prob);
        cnew(g_samp(s))=randsample(ksize,1,true,exp(w_scaled));
        %cnew(g_samp(s))=randsample(ksize,1,true,exp(prob.vector(:,g_samp(s))));
    end
%end
lsamp=cnew;
end